var util = require('util');
var path = require('path');
var events = require('events');
var Factory = require('./factory');
console.log(Factory)
/*
 * paths and encodeTypes must be an array! @param {Object} paths @param {Object}
 * encodeTypes @param {Object} callBack @api {Private}
 */
var ffmpeg2theora = module.exports = function(encodeTypes, callBack) {

	events.EventEmitter.call(this);
	var self = this;
	this.factory = (new Factory()).on('done', function(result) {
	self.emit('done', result);
	}).on('error', function(error) {
		self.emit('error', error);
	});
}
// So will act like an event emitter
util.inherits(ffmpeg2theora, events.EventEmitter);

ffmpeg2theora.prototype.batch = function(paths, outPutFolder, type, quality, callBack) {
	var self = this;
	if(!Array.isArray(paths)) {
		callBack(false)
	}
	var factory = this.factory;

	paths.forEach(function(Path) {
		path.exists(Path, function(exists) {
			if(!exists) {
				throw ('Path does not exists Path: ' + Path)
			}
			if(Array.isArray(type)) {
				for(var i = type.length - 1; i >= 0; i--) {
					factory.createEncode(Path, outPutFolder + '/' + path.basename(Path, path.extname(Path)) + '.' + type[i], quality);
				}
			} else {
				factory.createEncode(Path, outPutFolder + '/' + path.basename(Path, path.extname(Path)) + '.' + type, quality);
			}
		});
	})
	factory.open()
}
ffmpeg2theora.prototype.start = function() {
	this.factory.runQuta()
}
ffmpeg2theora.prototype.getActive = function() {
	return this.factory.activeJobs
}